BeerOverflow/BeerOverflow/Controllers/BreweriesController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.EntityFrameworkCore;
using BeerOverflow.Data.BeerOverflowContext;
using BeerOverflow.Data.Entities;
using BeerOverflow.Services.Contracts;
using BeerOverflow.Mappers;
using BeerOverflow.Models;
using Microsoft.AspNetCore.Authorization;

namespace BeerOverflow.Controllers
{
    public class BreweriesController : Controller
    {
        private readonly IBreweryService breweryService;
        private readonly ICountryService countryService;

        public BreweriesController(IBreweryService breweryService, ICountryService countryService)
        {
            this.breweryService = breweryService ?? throw new ArgumentNullException(nameof(breweryService));
            this.countryService = countryService ?? throw new ArgumentNullException(nameof(countryService));
        }

        // GET: Breweries
        public async Task<IActionResult> Index()
        {
            var breweries = await this.breweryService.GetAllBreweriesAsync();
            var result = breweries.GetViewModels();
            return View(result);
        }

        // GET: Breweries/Details/5
        public async Task<IActionResult> Details(int id)
        {
            var brewery = await this.breweryService.GetBreweryAsync(id);
            var result = brewery.GetViewModel();
            if (brewery == null)
            {
                return NotFound();
            }

            return View(result);
        }
        [Authorize(Roles = "Admin, User")]
        // GET: Breweries/Create
        public async Task<IActionResult> Create()
        {
            var brewery = new BreweryViewModel();
            var countries = await this.countryService.GetAllCountriesAsync();

            brewery.Countries = countries.Select(b => new SelectListItem(b.Name, b.Name)).ToList();

            return View(brewery);
        }
        [Authorize(Roles = "Admin, User")]
        // POST: Breweries/Create
        // To protect from overposting attacks, enable the specific properties you want to bind to, for 
        // more details, see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Create(BreweryViewModel brewery)
        {
            if (ModelState.IsValid)
            {
                var dto = brewery.GetDTO();
                await this.breweryService.CreateBreweryAsync(dto);
                return RedirectToAction(nameof(Index));
            }
            return View(brewery);
        }
        [Authorize(Roles = "Admin")]
        // GET: Breweries/Edit/5
        public async Task<IActionResult> Edit(int id)
        {
            var brewery = await this.breweryService.GetBreweryAsync(id);
            var result = brewery.GetViewModel();
            if (brewery == null)
            {
                return NotFound();
            }
            return View(result);
        }
        [Authorize(Roles = "Admin")]
        // POST: Breweries/Edit/5
        // To protect from overposting attacks, enable the specific properties you want to bind to, for 
        // more details, see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Edit(int id, BreweryViewModel brewery)
        {
            if (id != brewery.Id)
            {
                return NotFound();
            }

            if (ModelState.IsValid)
            {
                await this.breweryService.UpdateBreweryAsync(id, brewery.Name);
                return RedirectToAction(nameof(Index));
            }
            return View(brewery);
        }
        [Authorize(Roles = "Admin")]
        // GET: Breweries/Delete/5
        public async Task<IActionResult> Delete(int id)
        {
            var brewery = await this.breweryService.GetBreweryAsync(id);
            var result = brewery.GetViewModel();

            if (brewery == null)
            {
                return NotFound();
            }
            return View(result);
        }
        [Authorize(Roles = "Admin")]
        // POST: Breweries/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> DeleteConfirmed(int id)
        {
            await this.breweryService.DeleteBreweryAsync(id);
            return RedirectToAction(nameof(Index));
        } 
    }
}

BeerOverflow/BeerOverflow/Controllers/CountriesController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.EntityFrameworkCore;
using BeerOverflow.Data.BeerOverflowContext;
using BeerOverflow.Data.Entities;
using BeerOverflow.Services.Contracts;
using BeerOverflow.Models;
using BeerOverflow.Mappers;
using Microsoft.AspNetCore.Authorization;

namespace BeerOverflow.Controllers
{
    public class CountriesController : Controller
    {
        private readonly ICountryService countryService;

        public CountriesController(ICountryService countryService)
        {
            this.countryService = countryService ?? throw new ArgumentNullException(nameof(countryService));
        }

        // GET: Countries
        public async Task<IActionResult> Index()
        {
            var countries = await this.countryService.GetAllCountriesAsync();
            var result = countries.GetViewModels();

            return View(result);
        }

        // GET: Countries/Details/5
        public async Task<IActionResult> Details(int id)
        {
            var country = await this.countryService.GetCountryAsync(id);
            var result =country.GetViewModel();
               
            if (country == null)
            {
                return NotFound();
            }

            return View(result);
        }
        [Authorize(Roles = "Admin, User")]
        // GET: Countries/Create
        public async Task<IActionResult> Create()
        {
            return View();
        }
        [Authorize(Roles = "Admin, User")]
        // POST: Countries/Create
        // To protect from overposting attacks, enable the specific properties you want to bind to, for 
        // more details, see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Create(CountryViewModel country)
        {
            if (ModelState.IsValid)
            {
                var dto = country.GetDTO();
                await this.countryService.CreateCountryAsync(dto);
                return RedirectToAction(nameof(Index));
            }
            return View(country);
        }
        [Authorize(Roles = "Admin")]
        // GET: Countries/Edit/5
        public async Task<IActionResult> Edit(int id)
        {
            var country = await this.countryService.GetCountryAsync(id);
            var result = country.GetViewModel();
            if (country == null)
            {
                return NotFound();
            }
            return View(result);
        }
        [Authorize(Roles = "Admin")]
        // POST: Countries/Edit/5
        // To protect from overposting attacks, enable the specific properties you want to bind to, for 
        // more details, see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Edit(int id, CountryViewModel country)
        {
            if (id != country.Id)
            {
                return NotFound();
            }

            if (ModelState.IsValid)
            { 
                await this.countryService.UpdateCountryAsync(id, country.Name);
                return RedirectToAction(nameof(Index));
            }
            return View(country);
        }
        [Authorize(Roles = "Admin")]
        // GET: Countries/Delete/5
        public async Task<IActionResult> Delete(int id)
        {
            var country = await this.countryService.GetCountryAsync(id);
            var result = country.GetViewModel();
            if (country == null)
            {
                return NotFound();
            }
            return View(result);
        }
        [Authorize(Roles = "Admin")]
        // POST: Countries/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> DeleteConfirmed(int id)
        {
            await this.countryService.DeleteCountryAsync(id);
            return RedirectToAction(nameof(Index));
        }

    }
}

BeerOverflow/BeerOverflow/Controllers/StylesController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.EntityFrameworkCore;
using BeerOverflow.Data.BeerOverflowContext;
using BeerOverflow.Data.Entities;
using BeerOverflow.Services.Contracts;
using BeerOverflow.Mappers;
using BeerOverflow.Models;
using Microsoft.AspNetCore.Authorization;

namespace BeerOverflow.Controllers
{
    public class StylesController : Controller
    {
        private readonly IStyleService styleService;

        public StylesController(IStyleService styleService)
        {
            this.styleService = styleService ?? throw new ArgumentNullException(nameof(styleService));
        }

        // GET: Styles
        public async Task<IActionResult> Index()
        {
            var styles = await this.styleService.GetAllStylesAsync();
            var result = styles.GetViewModels();
            return View(result);
        }

        // GET: Styles/Details/5
        public async Task<IActionResult> Details(int id)
        {
            var style = await this.styleService.GetStyleAsync(id);
            var result = style.GetViewModel();
            if (style == null)
            {
                return NotFound();
            }

            return View(result);
        }
        [Authorize(Roles = "Admin, User")]
        // GET: Styles/Create
        public async Task<IActionResult> Create()
        {
            return View();
        }
        [Authorize(Roles = "Admin, User")]
        // POST: Styles/Create
        // To protect from overposting attacks, enable the specific properties you want to bind to, for 
        // more details, see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Create(StyleViewModel style)
        {
            if (ModelState.IsValid)
            {
                var dto = style.GetDTO();
                await this.styleService.CreateStyleAsync(dto);
                return RedirectToAction(nameof(Index));
            }
            return View(style);
        }
        [Authorize(Roles = "Admin")]
        // GET: Styles/Edit/5
        public async Task<IActionResult> Edit(int id)
        {
            var style = await this.styleService.GetStyleAsync(id);
            var result = style.GetViewModel();
            if (style == null)
            {
                return NotFound();
            }
            return View(result);
        }
        [Authorize(Roles = "Admin")]
        // POST: Styles/Edit/5
        // To protect from overposting attacks, enable the specific properties you want to bind to, for 
        // more details, see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Edit(int id, StyleViewModel style)
        {
            if (id != style.Id)
            {
                return NotFound();
            }

            if (ModelState.IsValid)
            {
                await this.styleService.UpdateStyleAsync(id, style.Name);
                return RedirectToAction(nameof(Index));
            }
            return View(style);
        }
        [Authorize(Roles = "Admin")]
        // GET: Styles/Delete/5
        public async Task<IActionResult> Delete(int id)
        {
            var style = await this.styleService.GetStyleAsync(id);
            var result = style.GetViewModel();
            return View(result);
        }
        [Authorize(Roles = "Admin")]
        // POST: Styles/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> DeleteConfirmed(int id)
        {
            await this.styleService.DeleteStyleAsync(id);
            return RedirectToAction(nameof(Index));
        } 
    }
}

BeerOverflow/BeerOverflow/Controllers/UsersController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.EntityFrameworkCore;
using BeerOverflow.Data.BeerOverflowContext;
using BeerOverflow.Data.Entities;
using BeerOverflow.Services.Contracts;
using Microsoft.AspNetCore.Identity;
using BeerOverflow.Models;
using BeerOverflow.Mappers;
using Microsoft.AspNetCore.Authorization;

namespace BeerOverflow.Controllers
{
    public class UsersController : Controller
    {
        private readonly IUserService userService;
        private readonly UserManager<User> userManager;

        public UsersController(IUserService userService, UserManager<User> userManager)
        {
            this.userManager = userManager ?? throw new ArgumentNullException(nameof(userManager));
            this.userService = userService ?? throw new ArgumentNullException(nameof(userService));
        }

        [Authorize(Roles = "Admin, User")]
        // GET: Users/Details/5
        public async Task<IActionResult> MyPage()
        {
            var user = await userManager.GetUserAsync(User);

            var vm = new WishListViewModel();
            vm.Username = user.UserName;
            vm.Country = user.Country;
            var dtosWish = await this.userService.RetreiveWishListAsync(user.Id);
            vm.WishLists = dtosWish.GetViewModels();
            var dtosDrank = await this.userService.RetreiveDrankListAsync(user.Id);
            vm.DrankLists = dtosDrank.GetViewModels();

            return View(vm);
        }

        [Authorize(Roles = "Admin, User")]
        public async Task<IActionResult> AddToWishList(int beerId)
        {
            if (ModelState.IsValid)
            {
                var user = await this.userManager.GetUserAsync(User);
                await this.userService.AddToWishListAsync(user.Id, user, beerId);

                return RedirectToAction($"Details", "Beers", new { ID = beerId });
            }
            return View();
        }
        [Authorize(Roles = "Admin, User")]
        public async Task<IActionResult> RemoveFromWishList(int beerId)
        {
            if (ModelState.IsValid)
            {
                var user = await this.userManager.GetUserAsync(User);
                await this.userService.RemoveFromWishListAsync(user.Id, user, beerId);

                return RedirectToAction("MyPage");
            }
            return View();
        }
        [Authorize(Roles = "Admin, User")]
        public async Task<IActionResult> AddToDrankList(int beerId)
        {
            if (ModelState.IsValid)
            {
                var user = await this.userManager.GetUserAsync(User);
                await this.userService.AddToDrankListAsync(user.Id, user, beerId);

                return RedirectToAction($"Details", "Beers", new { ID = beerId });
            }
            return View();
        }
        [Authorize(Roles = "Admin, User")]
        public async Task<IActionResult> RemoveFromDrankList(int beerId)
        {
            if (ModelState.IsValid)
            {
                var user = await this.userManager.GetUserAsync(User);
                await this.userService.RemoveFromDrankListAsync(user.Id, user, beerId);

                return RedirectToAction("MyPage");
            }
            return View();
        }

    }
}

BeerOverflow/BeerOverflow/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    @RenderSection("head", required: false)
    <link runat="server" rel="shortcut icon" href="~/lib/myicon.ico" type="image/x-icon" />
    <link runat="server" rel="icon" href="~/lib/myicon.ico" type="image/ico" />
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - BeerOverflow</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" />

<style>
    #a:hover {
        font-size: 150%;
        color: slategray
    }
</style>
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">       
          
            <div class="container">
                <img src="https://external-content.duckduckgo.com/iu/?u=https%3A%2F%2Firp-cdn.multiscreensite.com%2Ff9babea6%2Fdms3rep%2Fmulti%2Fmobile%2FIcon_beer-500x500.png&f=1&nofb=1" height="50" width="50" />
                <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">BeerOverflow</a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex flex-sm-row-reverse">
                    <partial name="_LoginPartial" />

                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a id="a" class="nav-link text-dark" asp-area="" asp-controller="Beers" asp-action="Index">Beers</a>
                        </li>
                        <li class="nav-item">
                            <a id="a" class="nav-link text-dark" asp-area="" asp-controller="Countries" asp-action="Index">Countries</a>
                        </li>
                        <li class="nav-item">
                            <a id="a" class="nav-link text-dark" asp-area="" asp-controller="Styles" asp-action="Index">Styles</a>
                        </li>
                        <li class="nav-item">
                            <a id="a" class="nav-link text-dark" asp-area="" asp-controller="Breweries" asp-action="Index">Breweries</a>
                        </li>
                        @if (User.Identity.IsAuthenticated)
                        {
                            <li class="nav-item">
                                <a id="a" class="nav-link text-dark" asp-area="" asp-controller="Users" asp-action="MyPage">MyPage</a>
                            </li>
                        }
                        @if (User.IsInRole("Admin"))
                        {
                            <li class="nav-item">
                                <a id="a" class="nav-link text-dark" asp-area="Admin" asp-controller="Users" asp-action="Index">Users</a>
                            </li>
                        }
                        @if (User.IsInRole("Admin"))
                        {
                            <li class="nav-item">
                                <a id="a" class="nav-link text-dark" asp-area="Admin" asp-controller="Users" asp-action="AllFlaggedReviews">Flagged Reviews</a>
                            </li>
                        }
                        <li class="nav-item">
                            <a id="a" class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>
    </header>

    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>


    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2020 - BeerOverflow - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @RenderSection("Scripts", required: false)
</body>
</html>